﻿// gdplayer 0.9.5
// 2.3.2011
// Copyright 2009 - 2011 Zdenek Canik
// All Rights Reserved.
// http://gdplayer.blogspot.com

var version = 095;
var gdp_version = "gdplayer 0.9.5";

var id = 0;
var np_station = "";
var np_group = "";

var stream = new Array();
var group = new Array();
var server_groups = new Array();

var player;
var player_loaded = false;

var date_time = true;
var last_date = null;
var bgrd_id = 1;
var anim = null;

//var fixed_size = false;
var auto_play = false;
var updates = true;

var status_timeout = 10;
var status_enabled = true;
var status_data = "";
var status_bank = 0;

var buttons_visible = false;
var ctrl_state = false;

options.putDefaultValue("playlist", "default");
options.putDefaultValue("last_stream", 0);
options.putDefaultValue("auto_play", false);
options.putDefaultValue("updates", true);
options.putDefaultValue("date_time", 1);
options.putDefaultValue("main_opacity", true);
options.putDefaultValue("info_opacity", false);
options.putDefaultValue("date_time_opacity", false);
options.putDefaultValue("volume", "50");
options.putDefaultValue("opacity", 100);
options.putDefaultValue("bgrd", 1);
//options.putDefaultValue("fixed_size", false);

//---------------------------------------------------------------------------------------------------------- ON OPEN
function view_onOpen() {
//	view.resizable = options.getValue("fixed_size");
	view_onSizing();
	global_opacity = options.getValue("opacity");
	id = options.getValue("last_stream");
	auto_play = options.getValue("auto_play");
	date_time = options.getValue("date_time");
	main_opacity = options.getValue("main_opacity");
	info_opacity = options.getValue("info_opacity");
	date_time_opacity = options.getValue("date_time_opacity");

	volume_bar.value = options.getValue("volume");
	bgrd_id = options.getValue("bgrd");
	
	fnLoadMyList();
	fnTimeUpdate();

	fnChangeOpacity(String(global_opacity + "%"));
	bgrd.src = "images/bgrd_" + bgrd_id + "_undocked.png";
	
  plugin.onAddCustomMenuItems = fnCustomMenu;

	if (date_time!=0) { 
		lbl_title.width = div_info.width - 70;
	} else {
		lbl_title.width = div_info.width;
	}

	lbl_day_of_week.trimming = "character-ellipsis";

	lbl_title.innerText = gdp_version;
	fnChangeTooltips(id);
	
	btn_mute.tooltip = MUTE;
	volume_bar.tooltip = VOLUME;
	btn_options.tooltip = OPTIONSTIP;
	btn_clock.tooltip = OPT_DATE_TIME;
	btn_clock.image = "images/btn_clock_" + date_time + ".png";
	
	fnRefreshStatus();
	setInterval('fnTimeUpdate()', 1000);

	if (updates) { fnChkUpdates(); }

}
//---------------------------------------------------------------------------------------------------------- ADD WMP EMBED
function fnAddWMPEmbed() {
  if (player_loaded) { return; }   

  var str = "<object name='WMPEmbed'";
  str += "      enabled='true' visible='true'";
  str += "      classid='clsid:6BF52A52-394A-11d3-B153-00C04F79FAA6'";
  str += "      playstatechange='fnPlayerStateChanged()'";
	str += "      type='application/x-oleobject'";
	str += "			error='fnPlayerError()'>";
  str += "  <param name='enableContextMenu' value='false'/>";
  str += "  <param name='enableErrorDialogs' value='false '/>";
	str += "	<param name='autoStart' value='false'/>";
	str += "	<param name='uiMode' value='invisible'/>";
  str += "</object>";
  
	view.appendElement(str);

	player = WMPEmbed.object;
  player_loaded = true;
}

//---------------------------------------------------------------------------------------------------------- NEXT / PREV
function fnNextStation() {
	if (!stream.length > 0) { return; }
	id == stream.length - 1 ? id = 0 : ++id;
	fnUpdateInfo();
}

function fnPrevStation() {
	if (!stream.length > 0) { return; }
	id == 0 ? id = stream.length - 1 : --id;
	fnUpdateInfo();
}

function fnUpdateInfo() {
	if(player != null && player.playState != 3) {
		np_station = stream[id].name;
		np_group = stream[id].group;
	}

	status_bank = 97;
	fnRefreshStatus();

	btn_play.visible = "true";
	btn_stop.visible = "false";

	id == 0 ? btn_prev.tooltip = PREVIOUS + " (" + stream[stream.length - 1].name + ")" : btn_prev.tooltip = PREVIOUS + " (" + stream[id - 1].name + ")";
	id == stream.length - 1 ? btn_next.tooltip = NEXT + " (" + stream[0].name + ")" : btn_next.tooltip = NEXT + " (" + stream[id + 1].name + ")";
	btn_play.tooltip = PLAY + " (" + stream[id].name + ")";

	if (options.getValue("auto_play")) { fnPlay(); }
}

//---------------------------------------------------------------------------------------------------------- PLAY / STOP
function fnPlay() {
	if (!player_loaded) { fnAddWMPEmbed(); }
	if (!stream.length > 0) { return; }
	try {
		options.putValue("last_stream", id);
		np_station = stream[id].name;
		np_group = stream[id].group;
		lbl_station.innerText = np_station;
		lbl_title.innerText = "";
		btn_play.visible = "false";
		btn_stop.visible = "true";

		fnChangeTooltips(id);
	
		var url = stream[id].url;
		var a = url.length - 4;
		if (url.substring(a) == ".pls") {
			fnPlayPLS();
		} else {
			player.url = stream[id].url;
			debug.trace("play : [ " + id + " ] " + stream[id].name + " @ " + player.url);
			player.controls.play();
		}
	} catch(e) {
		debug.error(e.message);
		status_bank = 96;
	}

	if (lbl_status.visible == false) { lbl_status.visible = true; lbl_download.visible = false; }

}

function fnStop() {
	player.controls.stop();
	player.close();
	lbl_title.innerText = gdp_version;
	btn_play.visible = "true";
	btn_stop.visible = "false";
	a_search.href = "http://www.google.com";
	btn_search.tooltip = "Google";
}

//---------------------------------------------------------------------------------------------------------- VOLUME
function fnVolumeChange() {
	if (player != null) { player.settings.volume = volume_bar.value; }
	status_bank = 98;
	fnRefreshStatus();
	options.putValue("volume",volume_bar.value);
}
function fnMute () { 
	if (!player_loaded) { return; }
	player.settings.mute = !player.settings.mute;
	//debug.trace("mute : " + player.settings.mute);

	if (player.settings.mute) {
		btn_mute.image = "images/btn_mute_on.png";
	} else {
		btn_mute.image = "images/btn_mute_off.png";
	}
}

//------------------------------------------------------------------------------------------------------------- CLOCK ON / OFF
function fnClockOnOff() {
	//debug.trace(options.getValue("date_time"));
	date_time++;
	if (date_time == 3) { date_time = 0; } 

	options.putValue("date_time",date_time);
	btn_clock.image = "images/btn_clock_" + date_time + ".png";
	if (date_time != 0) { // DATE TIME ON
		//lbl_station.align = "left"; 
		//lbl_title.align = "left";
		//lbl_status.align = "left";
			lbl_title.width = 105;
	} else { // DATE TIME OFF
		//lbl_station.align = "center"; 
		//lbl_title.align = "center";
		//lbl_status.align = "center";
			lbl_title.width = 184;
	}
	status_bank = 94;
	fnRefreshStatus();
}


//---------------------------------------------------------------------------------------------------------- MOUSE WHEEL EVENTS
function fnMouseWheel() {
  if (event.wheelDelta > 0) {
		switch (ctrl_state) {
			case 17:	// shift + wheel
				// opacity up
				//if (global_opacity < 100) { fnChangeOpacity(String(global_opacity + 10)+"%"); }
			break;
			case 16: // ctrl + wheel
				if (volume_bar.value > 99) { volume_bar.value = 100; return; }
				volume_bar.value += 5;
			break;
			default:
				fnPrevStation(); // wheel only
		}
  } else {
		switch (ctrl_state) {
			case 17:	
			// opacity down
			//	if (global_opacity > 0) { fnChangeOpacity(String(global_opacity - 10)+"%");	}
			break;
			case 16:
				if (volume_bar.value < 1) { volume_bar.value = 0; return; }	
				volume_bar.value -= 5;
			break;
			default:
				fnNextStation();
		}
	}
}
//---------------------------------------------------------------------------------------------------------- KEY DOWN / UP
function fnKeyDown() {
  var KeyID = event.keyCode;
	//debug.trace(KeyID);
	switch (KeyID) {
		case 16: // shift
			ctrl_state = KeyID;
		break;
		case 17: // ctrl
			ctrl_state = KeyID;
		break;
		case 32: // space
			if (player_loaded && player.playstate == 3) { 
				fnStop(); 
			} else {
				fnPlay();
			}
		break;
		case 37: // <-
			fnPrevStation();
		break;
		case 38: // arrow up
			if (volume_bar.value > 99) { volume_bar.value = 100; return; }
			volume_bar.value += 5;
		break;
		case 39: // ->
			fnNextStation();
		break;
		case 40: // arrow down
			if (volume_bar.value < 1) { volume_bar.value = 0; return; }	
			volume_bar.value -= 5;
		break;
		case 77: // M
			fnMute();
		break;
	}
}

function fnKeyUp() {
	ctrl_state = 0;
}

//---------------------------------------------------------------------------------------------------------- REFRESH STATUS
function fnRefreshStatus() {
	if (status_bank > 10) {
		fnIsAnimating();
		lbl_status.opacity = 255;
	}

	switch (status_bank) {
		case 0: //default - player idle or stopped 
			lbl_station = "";
			lbl_title.innerText = gdp_version;
			status_data = "ready to play";
			//status_timeout = 10;
			status_enabled = false;
		break;
		case 1: //station + group
			status_timeout = 10;
			try {
				lbl_station.innerText = stream[options.getValue("last_stream")].name; //np_station;
				status_data = stream[options.getValue("last_stream")].group;
				//lbl_title.innerText = stream[id].url;
				id = options.getValue("last_stream");
				fnChangeTooltips(id);
			} catch(e) {
				lbl_title.innerText = gdp_version;
			}
		break;
		case 2: //wmp status
			status_data = fnGetPlayerState();
			status_timeout = 20;
		break;
		case 3: //station's homepage
			if (!stream.length > 0) { return; }
			status_data = stream[id].homepage;
			status_timeout = 20;
		break;
		case 4:
			status_data = "";
		break;
		case 94:
			status_data = OPT_DATE_TIME + ": ";
			if (date_time == 0) { status_data += OPT_OFF; }
			if (date_time == 1) { status_data += OPT_AMPM; }
			if (date_time == 2) { status_data += OPT_HOUR24; }			
			status_enabled = true;
			status_timeout = 5;
		break;
		case 96: //url error
			lbl_title.innerText = "no signal";
			status_enabled = true;
			status_timeout = 5;
		break;
		case 97: //prev / next
			status_data = stream[id].group;
			lbl_station.innerText = stream[id].name;
			fnChangeTooltips(id);
			status_enabled = true;
			status_timeout = 5;
		break;
		case 98: //volume
			status_data = VOLUME + " : " + volume_bar.value + "%";
			status_enabled = true;
			status_timeout = 5;
		break;
		case 99: //error - stream[] - fail
			lbl_station.innerText = "";
			lbl_title.innerText = gdp_version;
			status_data = "failed to build stations list...";
			status_enabled = true;
			status_timeout = 5;
		break;
	}
	
	if (player_loaded && player.playstate == 3) { 
		lbl_title.innerText = player.currentMedia.getItemInfo('Title');  
		a_search.href = "http://www.google.com/search?q=" + player.currentMedia.getItemInfo('Title');
		btn_search.tooltip = "Google: " + player.currentMedia.getItemInfo('Title'); 
	}

	lbl_status.innerText = status_data;// + " / " + status_enabled + " / " + status_timeout;
	view.caption = status_data;

	++status_bank;	
	if (status_bank >= 4) { status_bank = 1; }
}

function fnIsAnimating() {
	if (anim != null) {
		cancelAnimation(anim);
		anim = null;
	}
}

function fnStatusFadeOut() {
	fnIsAnimating();
	anim = beginAnimation("AnimateOut()",255,0,2500);
}
function fnStatusFadeIn() {
	fnIsAnimating();
	anim = beginAnimation("AnimateIn()",0,255,2500);
}

function AnimateOut() {
  lbl_status.opacity = event.value;
	if (event.value == 0) {
		fnRefreshStatus();
		fnStatusFadeIn();
	}
}
function AnimateIn() {
  lbl_status.opacity = event.value;
	if (event.value == 255) {
		status_enabled = true; 
	}
}

function fnPlayerStateChanged() {
	status_bank = 2;
	fnRefreshStatus();
}

//---------------------------------------------------------------------------------------------------------- TIME UPDATE
function fnTimeUpdate() {
  var time = new Date();
  var hours = time.getHours();
  var minutes = time.getMinutes();
	
	if (status_enabled == true) {
		--status_timeout;
		if (status_timeout == 3) {
			status_enabled = false;
			fnStatusFadeOut();
		}
	}

	if (date_time == 0) { return; }

  if (date_time == 2) {
		lbl_ampm.visible = false;
	} else {
		lbl_ampm.visible = true;
		lbl_ampm.innerText = (hours < 12) ? AM : PM;
		hours = (hours > 12) ? hours - 12 : hours;
		hours = (hours == 0) ? 12 : hours;
	}

	hours = (hours < 10 ? "0" : "") + hours;
	minutes = (minutes < 10 ? "0" : "") + minutes;
	lbl_time.innerText = hours + ":" + minutes;
	
	lbl_month.innerText = eval('M' + time.getMonth());
	if (time.getDate() < 10) { lbl_date.innerText = "0" + time.getDate(); } else { lbl_date.innerText =  time.getDate(); }
	lbl_day_of_week.innerText = eval('D' + time.getDay());
	lbl_year.innerText = time.getFullYear();
}
//---------------------------------------------------------------------------------------------------------- GET PLAYER STATE
function fnGetPlayerState() {
	if ((player != null) && (player_loaded == true)) {
		switch(player.playState) {
			case 0: return IDLE;
			case 1: return STOPPED;
			case 2: return PAUSED;
			case 3: 
					var att_value = player.currentMedia.getItemInfo('Title');
					lbl_title.innerText = att_value;
					return PLAYING + ": " + parseInt(player.network.bitRate/1000) +" Kbps";
					
			break;
			case 4: return "";
			case 5: return ""; 
			case 6:
				//test_faze = 3;
				return BUFFERING;
			break;
			case 7: return WAITING;
			case 8: return MEDIA_ENDED;
			case 9: return TRANSITIONING;
			case 10: return READY_TO_PLAY;
			case 11: return RECONECTING;
		}
	} else {
		return gdp_version;
	}
}

function fnPlayerError() {
	var errDesc = player.error.item(0).errorDescription;
	btn_play.visible = "true";
	btn_stop.visible = "false";
}

//---------------------------------------------------------------------------------------------------------- FADE IN / OUT
function fnFadeIn() {
	if (buttons_visible == true) { return; }
	if(player_loaded == true) { 
		if (player.playState == 3) {
			btn_play.visible = "false";
			btn_stop.visible = "true";
		} else {
			btn_play.visible = "true";
			btn_stop.visible = "false";
		}
	}

	beginAnimation("lbl_title.opacity = event.value", 200, 0, 200);
	beginAnimation("time.opacity = event.value", time.opacity, 0, 200);
	beginAnimation("buttons.opacity = event.value", 0, 255, 200);
	
	// version 0	
	beginAnimation("buttons.y = event.value", 0, (div_main.height - 16) / 2, 200);
  // version 1
	beginAnimation("btn_prev.x = event.value", 0, 50, 200);
	beginAnimation("btn_next.x = event.value", 181, 131, 200);

	beginAnimation("volume_bar.opacity = event.value", 0, 255, 200);
	beginAnimation("btn_clock.opacity = event.value", 0, 255, 200);
	beginAnimation("btn_mute.opacity = event.value", 0, 255, 200);
	beginAnimation("btn_options.opacity = event.value", 0, 255, 200);
	beginAnimation("btn_menu.opacity = event.value", 0, 255, 200);
	beginAnimation("btn_search.opacity = event.value", 0, 255, 200);
	
	var a=options.getValue("opacity");
	if (info_opacity) { beginAnimation("div_info.opacity = event.value", (255/100)*a, 255, 200); }
	if (div_main.opacity!=255) { beginAnimation("div_main.opacity = event.value", div_main.opacity, 255, 200); }
	buttons_visible = true;
}

function fnFadeOut() {
	if (buttons_visible == false) { return; }

	beginAnimation("lbl_title.opacity = event.value", 0, 200, 200);
	beginAnimation("buttons.opacity = event.value", 255, 0, 200);
	
	// version 0 
	beginAnimation("buttons.y = event.value",  (div_main.height - 16) / 2 , (div_main.height-18), 200);	
	// version 1
	beginAnimation("btn_prev.x = event.value", 50, 0, 200);
	beginAnimation("btn_next.x = event.value", 131, 181, 200);

	beginAnimation("volume_bar.opacity = event.value", 255, 0,200);
	beginAnimation("btn_mute.opacity = event.value", 255, 0,200);
	beginAnimation("btn_clock.opacity = event.value", 255, 0,200);
	beginAnimation("btn_options.opacity = event.value", 255, 0,200);
	beginAnimation("btn_menu.opacity = event.value", 255, 0,200);
	beginAnimation("btn_search.opacity = event.value", 255, 0,200);
	
	var a=options.getValue("opacity");
	if (info_opacity) {
		beginAnimation("div_info.opacity = event.value", 255,(255/100)*a , 200);
	}
	if (date_time_opacity) { 
		beginAnimation("time.opacity = event.value", 0,(255/100)*a , 200);
	} else {
		beginAnimation("time.opacity = event.value", 0,255 , 200);
	}
	if (main_opacity) {
		if(a!=100) { beginAnimation("div_main.opacity = event.value", 255,(255/100)*a , 200); }
	}
	buttons_visible = false;
}

//---------------------------------------------------------------------------------------------------------- RIGHT CLICK MENU
function fnCustomMenu(menu) {
// fixed_size
//	menu.AddItem("n", fixed_size ? gddMenuItemFlagChecked : 0, onResize);
	
// opacity
	var opacSub = menu.AddPopup(OPACITY);
		for (var i=100; i>=0; i-=10) {
			var proc = i + "%";
			opacSub.AddItem(proc, options.getValue("opacity") == i ? gddMenuItemFlagChecked : 0, fnChangeOpacity);
		}
		opacSub.AddItem("", gddMenuItemFlagGrayed, null);	//separator
		opacSub.AddItem(OP_MAIN, options.getValue("main_opacity") ? gddMenuItemFlagChecked : 0, onItemOpacity);
		opacSub.AddItem(OP_STATION, options.getValue("info_opacity") ? gddMenuItemFlagChecked : 0, onItemOpacity);
		opacSub.AddItem(OP_TIME, options.getValue("date_time_opacity") ? gddMenuItemFlagChecked : 0, onItemOpacity);
}

function fnChangeOpacity(itemText) {
		var x = itemText.substring(0, itemText.indexOf("%"));
		global_opacity = parseInt(x);
		options.putValue("opacity",global_opacity);
}

//---------------------------------------------------------------------------------------------------------- OPTIONS ON CHANGE
function view_onOptionChanged() {
var o = (255/100) * global_opacity;
  switch(event.propertyName) {
		case "date_time":
			date_time = options.getValue("date_time");
			if (date_time != 0) {
				lbl_title.width = div_info.width - 70;
				time.visible = true;
			} else {
				lbl_title.width = div_info.width;
				time.visible = false;
			}
			
		break;
		case "opacity":
			main_opacity ? div_main.opacity = o : div_main.opacity = 255;
			info_opacity ? div_info.opacity = o : div_info.opacity = 255;
			date_time_opacity ? time.opacity = o : time.opacity = 255;
		break;
		case "main_opacity":
			main_opacity ? div_main.opacity = o : div_main.opacity = 255;
		break;
		case "info_opacity":
			debug.trace(info_opacity);
			info_opacity ? div_info.opacity = o : div_info.opacity = 255;
		break;
		case "date_time_opacity":
			date_time_opacity ? time.opacity = o : time.opacity = 255;
		break;
		case "last_stream":
			if (!stream.length > 0) { 
				lbl_station.innerText = "";
				lbl_title.innerText = EMPTY_PLAYLIST;
				return; 
			}
			np_station = stream[id].name;
			lbl_station.innerText = np_station;
		break;
	case "play_id":
			if (!stream.length > 0) { 
				lbl_station.innerText = "";
				lbl_title.innerText = EMPTY_PLAYLIST;
				return; 
			}

			if (stream[id].url == stream[options.getValue("play_id")].url) { return; }
			id = options.getValue("play_id");
			fnPlay();
		break;
		case "playlist":
			fnLoadMyList();
		break;
		case "bgrd":
			bgrd.src = "images/bgrd_" + options.getValue("bgrd") + "_undocked.png";
			fnChangeSkin(options.getValue("bgrd"));
		break;	
	//	case "fixed_size":
	//		view.resizable = !options.getValue("fixed_size");
	//	break;
		case "play":
				if (player_loaded) {
					if (player.playState == 3) {
						fnStop();
						return;
					}
				}
				id = options.getValue("play");
				fnPlay();
		break;
	}
}
/*
function onResize() {
	fixed_size = !fixed_size;
  options.putValue("fixed_size", fixed_size);
}*/

function onItemOpacity(x) {
	switch (x) {
		case OP_MAIN:
			main_opacity = !main_opacity
			options.putValue("main_opacity", main_opacity);
		break;
		case OP_STATION:
			info_opacity = !info_opacity
			options.putValue("info_opacity", info_opacity);
		break;
		case OP_TIME:
			date_time_opacity = !date_time_opacity;
			options.putValue("date_time_opacity", date_time_opacity);
		break;
	}
}

//---------------------------------------------------------------------------------------------------------- GET MEDIA INFO
function fnGetMediaInfo() {
	if (player_loaded == false) { return; }
	if (player.currentMedia != null) {
		var att_num = player.currentMedia.attributeCount;
		var a = "";
		a += "<b>" + stream[id].group + "</b>";
		a += "<div class='head'>" + stream[id].name + "</div>";
		a += "<div class='details'><a href='" + stream[id].homepage + "'><b>" + stream[id].homepage + "</b></a></div>";

		a += "		<table width=100%>";
		for (var i=0; i<att_num; ++i) {
			var att_name = player.currentMedia.getAttributeName(i);
			var att_value = player.currentMedia.getItemInfo(att_name);
			var att_temp = att_name.toLowerCase();
			
			if (att_name == "Title") { var title = att_value; }
			a += "<tr><td valign='top' nowrap background='#AAAAAA'><b>" + att_name + "</b></td>";
			a += "<td>";
			if (att_temp.indexOf("url") != -1) {
				a += "<a href='" + att_value + "'>" + att_value + "</a>";
			} else {
				a += att_value;
			}
			a += "</td></tr>";
		}
		a += "</table>";
		a += "<br><b>";
		a += "<a href='http://gdplayer.blogspot.com/2009/09/report-broken-links.html'>" + REPORT + "</a></b>";
		fnViewHTML(title,a);
	}
}

//---------------------------------------------------------------------------------------------------------- SHOW HTML DETAILS
function fnViewHTML(title,data) {
	var output =  "<html>";
			output += "<head>";
			output += "	<META HTTP-EQUIV='Content-Type' CONTENT='text/html; charset=windows-1250'>";
			output += "	<style type='text/css'>";
			output += "		body { width: 400px; height:400px; font-family:arial,sans-serif; font-size: 10px;}";
			output += "		td { font-family:arial,sans-serif; font-size: 10px; padding: 0px 2px 0px 2px;}";
			output += "		.head { width:100%; padding: 5 5 5 5px; background-color: #f68d10; font-size: 12px; color: #ffffff; font-weight: bold;}";
			output += "    .details { text-align: right; width:100%; padding: 2 5 10 5px; background-color: #ffffff; font-size: 10px; color: #000000;}";
			output += "	</style>";
			output += "</head>";
			output += "<body bgcolor='#FFFFFF' text='#000000' link='#0046b2' vlink='#0046b2' alink='#0046b2' scroll='yes'>";
			output += data;
			output += "</body>";
			output += "</html>";

	var htmlDetailsView = new DetailsView();
  
	htmlDetailsView.html_content = true;
	htmlDetailsView.setContent("", undefined, output, false, 0);
	plugin.showDetailsView(htmlDetailsView, "", 0, null);
}

//---------------------------------------------------------------------------------------------------------- SAVE MYLIST.XML
function fnSaveMylistXML() {
	var xmlDoc = new DOMDocument();
  xmlDoc.async = false;

	var xml_string = "<?xml version=\"1.0\" encoding=\"windows-1250\"?>\n";
	xml_string += "<general>\n";

	for (var i=0; i<group.length; ++i) {
		xml_string += "<group name='" + group[i] + "'>\n";
		for (var j=0; j<stream.length; ++j) {
			if (stream[j].group == group[i]) {
				xml_string += "<stream>\n";
				xml_string += "<name>" + stream[j].name + "</name>\n";
				xml_string += "<url>" + stream[j].url +"</url>\n";
				xml_string += "<homepage>" + stream[j].homepage +"</homepage>\n";
				xml_string += "</stream>\n";
			}
		}
		xml_string += "</group>\n";
	}
	xml_string += "</general>";

	xmlDoc.loadXML(xml_string);
	
	try { 
		xmlDoc.save("gdplayer_playlist.xml");
	} catch(e) {
		debug.error(errorDescription);
	}
	xmlDoc.close;
	debug.info("gdplayer_playlist.xml saved...");
}

//---------------------------------------------------------------------------------------------------------- SHOW PLAYLIST MENU
function onDetailsViewFeedback(detailsViewFlags) {

  if (detailsViewFlags == gddDetailsViewFlagNone) {
    // The user closed the details view. Do something here if you have to.
  } else if (detailsViewFlags == gddDetailsViewFlagRemoveButton) {
    // The user clicked on the remove button. Remove this element from the list. he doesn't want it.
  }
}
function fnShowMenu() {
	var detailsView = new DetailsView();
	detailsView.SetContent(
    "", 												// Item's displayed website/news source. -> not used for an XML details view
    undefined, 						// Time created
    "menu.xml", 					// The XML file
    false, 										// Whether time is shown as absolute time
    0); 												// Content layout flags

	plugin.showDetailsView(detailsView, "Playlist: " + stream.length + " " + OPT_STATIONS, gddDetailsViewFlagNone, onDetailsViewFeedback);
}

//---------------------------------------------------------------------------------------------------------- SIZING
function view_onSizing() {
/*
 if (event.width < 180) { event.width = 180; return; }
 if (event.height < 60) { event.height = 60; return; }

	var w = event.width;
	var h = event.height;

*/
	var w = 200;
	var h = 100;
	div_main.width = w;
	div_main.height = h;
	bgrd.width = w;
	bgrd.height = h;
	div_info.width = w - 10;
	div_info.height = h - 6;
	lbl_station.width = w - 10;
	lbl_status.width = w - 10;

	if (date_time != 0) { 
		lbl_title.width = div_info.width - 70;
	} else {
		lbl_title.width = div_info.width;
	}

	lbl_title.height = h - 18;
	lbl_status.y = h - 21;
	time.x = w - 88;

	btn_menu.y = (h/2) - 4;
	btn_options.x = w - 20;
	btn_options.y = (h/2) + 12;
	btn_mute.x = w - 19;
	btn_mute.y = (h/2) - 5;

	//buttons.x = (w - 180) / 2;

	volume_bar.width = w - 60;
	volume_bar.y = h - 30;
}

//---------------------------------------------------------------------------------------------------------- UPDATES
function fnChkUpdates() {
	debug.info("checking updates...");

	var req = new XMLHttpRequest();
	var url = "http://" + server + "/gdplayer/version.txt?r=" + Math.random();
	
	debug.info("checking version: " + url);
	req.open("GET", url, true);
  req.onreadystatechange = function() {
      if (req.readyState == 4 && req.status == 200) {
				//debug.trace("version.txt is loaded & ready for use...");
				var ver_online = req.responseText;
				if (ver_online > version) {
					lbl_title.innerText = NEW_VERSION;
					lbl_download.visible = true;
					lbl_status.visible = false;
				}
      }
    };
  req.send();
}
function fnDownClick() {
	lbl_title.innerText = "";
	lbl_download.visible = false;
	lbl_status.visible = true;
}

//---------------------------------------------------------------------------------------------------------- CHANGE TOOLTIPS
function fnChangeTooltips(st_id) {
	debug.info("changing tooltips...");
	if(stream.length > 0) {
		st_id == 0 ? btn_prev.tooltip = PREVIOUS + " (" + stream[stream.length - 1].name + ")" : btn_prev.tooltip = PREVIOUS + " (" + stream[st_id -1].name + ")";
		st_id == stream.length - 1 ? btn_next.tooltip = NEXT + " (" + stream[0].name + ")" : btn_next.tooltip = NEXT + " (" + stream[st_id + 1].name + ")";
		btn_play.tooltip = PLAY + " (" + stream[st_id].name + ")";
	} else {
		btn_prev.tooltip = PREVIOUS;
		btn_next.tooltip = NEXT;
		btn_play.tooltip = PLAY;
	}
}

//-------------------------------------- CHANGE SKIN
function fnChangeSkin(id) {
	//alert("skin: " + id);
	switch (id) {
		case 1: //default
			lbl_station.color  = "#FFFFFF";
			lbl_title.color = "#FFFC06";
			lbl_status.color = "#C0C0C0";
			lbl_time.color  = "#FFFFFF";
			lbl_ampm.color  = "#FFFFFF";
			lbl_date.color  = "#DDDDDD";
			lbl_month.color  = "#C0C0C0";
			lbl_day_of_week.color  = "#DDDDDD";
			lbl_year.color  = "#C0C0C0";
		break;
		
		case 2: 
			lbl_station.color  = "#FAFAFA";
			lbl_title.color = "#e28313";
			lbl_status.color = "#C0C0C0";
			lbl_time.color  = "#e28313";
			lbl_ampm.color  = "#e28313";
			lbl_date.color  = "#e28313";
			lbl_month.color  = "#CCCCCC";
			lbl_day_of_week.color  = "#FDFDFD";
			lbl_year.color  = "#CCCCCC";
		break;
		
		case 3: 
			lbl_station.color  = "#FFFFFF";
			lbl_title.color = "#FFFC06";
			lbl_status.color = "#FFFC06";
			lbl_time.color  = "#FFFFFF";
			lbl_ampm.color  = "#FFFFFF";
			lbl_date.color  = "#DDDDDD";
			lbl_month.color  = "#C0C0C0";
			lbl_day_of_week.color  = "#DDDDDD";
			lbl_year.color  = "#C0C0C0";
		break;
		
		case 4: 
			lbl_station.color  = "#e3ac28";
			lbl_title.color = "#d29c0f";
			lbl_status.color = "#9c6e00";
			lbl_time.color  = "#d29c0f";
			lbl_ampm.color  = "#d29c0f";
			lbl_date.color  = "#d29c0f";
			lbl_month.color  = "#9c6e00";
			lbl_day_of_week.color  = "#d29c0f";
			lbl_year.color  = "#7d5300";
		break;
		
		case 5: 
			lbl_station.color  = "#FFFFFF";
			lbl_title.color = "#FFFC06";
			lbl_status.color = "#FFFFFF";
			lbl_time.color  = "#FFFFFF";
			lbl_ampm.color  = "#FFFFFF";
			lbl_date.color  = "#DDDDDD";
			lbl_month.color  = "#FFFC06";
			lbl_day_of_week.color  = "#FFFC06";
			lbl_year.color  = "#DDDDDD";
		break;
		
		case 9: 
			lbl_station.color  = "#FFF00F";
			lbl_title.color = "#DDDDDD";
			lbl_status.color = "#CCCCCC";
			lbl_time.color  = "#FFFFFF";
			lbl_ampm.color  = "#FFFFFF";
			lbl_date.color  = "#EEEEEE";
			lbl_month.color  = "#CCCCCC";
			lbl_day_of_week.color  = "#AAAAAA";
			lbl_year.color  = "#DDDDDD";
		break;
		
		default:
			lbl_station.color  = "#FFFFFF";
			lbl_title.color = "#FFFC06";
			lbl_status.color = "#C0C0C0";
			lbl_time.color  = "#FFFFFF";
			lbl_ampm.color  = "#FFFFFF";
			lbl_date.color  = "#FFFFFF";
			lbl_month.color  = "#C0C0C0";
			lbl_day_of_week.color  = "#DDDDDD";
			lbl_year.color  = "#C0C0C0";
	}
	return;
}