﻿// gdplayer 0.9.5
// 2.3.2011
// Copyright 2009 - 2011 Zdenek Canik
// All Rights Reserved.
// http://gdplayer.blogspot.com

var opt_stream = new Array();
var opt_group = new Array();
var opt_id = 0;
var opt_bgrd_id;
var focus = 0;
var np_id = options.getValue("last_stream");
var play = false;

function onOpen() {
	fnGetDefaultPlaylist();
	play = true;
}

function fnGetDefaultPlaylist() {
	//alert("options : loading local playlist...");
	var xmlDoc = new DOMDocument();
	try {
		xmlDoc.async = false;
		var result = xmlDoc.load("gdplayer_playlist.xml");
		if (!result) {
			alert("local gdplayer_playlist.xml : not found");
			return;
		}
		//alert("gdplayer_playlist.xml is loaded & ready for use...");
		fnGetData(xmlDoc);
		fnUpdateLstGroups();
	} catch(e) {
		alert(e.message);
	}
}

function fnGetData(data) {
	opt_group = [];
	opt_stream = [];

	var parseError = data.parseError;
	if (parseError.errorCode != 0) { debug.error(parseError.reason); }
	var objGroupList = data.getElementsByTagName("group");
	//alert("found : " + objGroupList.length + " group(s)");

	var id=-1;
	for (var i = 0; i < objGroupList.length; ++i) {
		var xmlItem = objGroupList.item(i);
		opt_group[i] = xmlItem.getAttribute("name");
		
		for (var j = 0; j < xmlItem.childNodes.length; ++j) {
			var child = xmlItem.childNodes.item(j);
			if (child.childNodes.length > 0) {
				++id;
				try {
					var http = child.childNodes[2].childNodes[0].nodeValue;
				} catch (e) {
					var http = "none";
				}
				opt_stream[id] = {
					name:child.childNodes[0].childNodes[0].nodeValue,
					url:child.childNodes[1].childNodes[0].nodeValue,
					homepage:http,
					group:opt_group[i]
				};
			}
		}
	}
}

// ------------------------------------------------------------------- GROUP TOOLS
function fnUpdateLstGroups(data) {
	lst_groups.removeAllElements();
	opt_group.length == 0 ? lst_stations.removeAllElements() : "";
	for (var i = 0; i < opt_group.length; ++i) {
		lst_groups.appendElement("<item value='" + i + "' name='" + opt_group[i] + "'><label height='16' valign='middle' size='9' color='#000000' font='Segoe UI' tooltip='" + opt_group[i] + "'>" + opt_group[i] + "</label></item>");
		if (opt_group[i] == opt_stream[np_id].group) { lst_groups.selectedIndex = i; }
	}

	 fnUpdateLstStreams();
}

// ------------------------------------------------------------------- STREAMS TOOLS
function fnUpdateLstStreams() {
	if ((opt_stream.length < 1) || (!lst_groups.selectedItem)) { lst_stations.removeAllElements(); return;}
	lst_stations.removeAllElements();
	var x = 0;
	for (var i = 0; i < opt_stream.length; ++i) {	
		if (opt_stream[i].group == lst_groups.selectedItem.name) {
			lst_stations.appendElement("<item value='" + i + "' name='" + opt_stream[i].name + "'><label height='16' valign='middle' size='9' color='#000000' font='Segoe UI' tooltip='" + opt_stream[i].name + "'>" + opt_stream[i].name + "</label></item>");
			if (i == np_id) { lst_stations.selectedIndex = x; }
			x++;
		}
	}
}

//----------------------------------------------------------------------------------- GET ID
function fnGetId() {
	try {
		var name = lst_stations.selectedItem.name;	
		var group = lst_groups.selectedItem.name;
	} catch(e) { debug.info(name +" "+ group);
		return; 
	}
	var id = null;
	
	for (var i = 0; i < opt_stream.length; i++) {
		if (group == opt_stream[i].group && name == opt_stream[i].name) { id = i; }
	}
	opt_id = id;
	return id;
}

//----------------------------------------------------------------------------------- PLAY ID
function fnPlayID() {
	if (!play) { return; }
	var id = fnGetId();	
	np_id = id;
	if (id == null) { return; }
	options.putValue("play_id",id);
}
