﻿// gdplayer 0.9.5
// 2.3.2011
// Copyright 2009 - 2011 Zdenek Canik
// All Rights Reserved.
// http://gdplayer.blogspot.com

var opt_stream = new Array();
var opt_group = new Array();
var opt_id = 0;
var focus = 0;
var move_group = "";

// ------------------------------------------------------------------- ON 	OPEN
function onOpen() {
	lbl_station.innerText = "gdplayer 0.9.5";
	a_homepage.innerText = OPT_INFO;
	lbl_url.innerText = OPT_COPY;
	fnGetDefaultPlaylist();
	lst_groups.selectedIndex = 0;
	lst_stations.selectedIndex = -1;
	preview.src = "images/bgrd_" + options.getValue("bgrd") + "_undocked.png";

	//debug.info(options.getValue("auto_play") + " / " + options.getValue("date_time") + " / " + options.getValue("am_pm"));

	chk_autoplay.value = options.getValue("auto_play");
	chk_updates.value = options.getValue("updates");

}

// ------------------------------------------------------------------- ON CANCEL
function onCancel() {
}

// ------------------------------------------------------------------- ON OK
function onOk() {
	fnSaveGDPXML();
	options.putValue("auto_play",chk_autoplay.value);
	options.putValue("updates",chk_updates.value);
	options.putValue("playlist",true);

//	debug.info(chk_datetime.value + " / _ " + chk_autoplay.value);
}

function fnGetDefaultPlaylist() {
	debug.info("options : loading local playlist...");
	var xmlDoc = new DOMDocument();
	try {
		xmlDoc.async = false;
		if(!xmlDoc.load("gdplayer_playlist.xml")) { 
			fnSaveDefaultGDPXML();
		} else {
		debug.trace("gdplayer_playlist.xml is loaded & ready for use...");
		fnGetData(xmlDoc);
		fnUpdateLstGroups();
		}
	} catch(e) {
		alert(e.message)
	}
}

function fnGetData(data) {
	opt_group = [];
	opt_stream = [];

	var parseError = data.parseError;
	if (parseError.errorCode != 0) { debug.error(parseError.reason); }

	var objGroupList = data.getElementsByTagName("group");
	debug.trace("found : " + objGroupList.length + " group(s)");

	var id=-1;
	for (var i = 0; i < objGroupList.length; ++i) {
		var xmlItem = objGroupList.item(i);
		opt_group[i] = xmlItem.getAttribute("name");
		
		for (var j = 0; j < xmlItem.childNodes.length; ++j) {
			var child = xmlItem.childNodes.item(j);
			if (child.childNodes.length > 0) {
				++id;
				try {
					var http = child.childNodes[2].childNodes[0].nodeValue;
				} catch (e) {
					var http = "none";
				}
				opt_stream[id] = {
					name:child.childNodes[0].childNodes[0].nodeValue,
					url:child.childNodes[1].childNodes[0].nodeValue,
					homepage:http,
					group:opt_group[i]
				};
			}
		}
	}
}

// ------------------------------------------------------------------- GROUP TOOLS
function fnUpdateLstGroups() {
	lst_groups.removeAllElements();
	opt_group.length == 0 ? lst_stations.removeAllElements() : "";
	for (var i = 0; i < opt_group.length; ++i) {
		if (opt_group[i] == move_group) { 
			lst_groups.appendElement("<item value='" + i + "' name='" + opt_group[i] + "' ondblclick='fnEditGroup();'><label height='16' valign='middle' size='9' font='Segoe UI' color='#FF0000'>" + opt_group[i] + "</label></item>");
		} else {			
			lst_groups.appendElement("<item value='" + i + "' name='" + opt_group[i] + "' ondblclick='fnEditGroup();'><label height='16' valign='middle' size='9' font='Segoe UI' color='#000000'>" + opt_group[i] + "</label></item>");
		}
	}
	lst_groups.selectedIndex = 0;
}

function fnNewGroup() {
	var name = view.prompt(OPT_NEWGROUP,"");
	for (var i = 0; i < opt_group.length; ++i) {
		if (opt_group[i] == name) { 
			//view.alert("stejny nazev");
		return;
		}
	}
	
	if(name) { 
		opt_group.push(name);
		fnUpdateLstGroups();
		lst_groups.selectedIndex = opt_group.length - 1;
	}
}

function fnDelGroup() {
	var temp_array = [];
	var str = "";

	for (var i=0; i<lst_groups.children.count; ++i) {
		if(lst_groups.children(i).selected) { 
			temp_array.push(lst_groups.children(i).name);
			str += "     " + opt_group[i] +"\n";
		}
	}

	if (confirm(OPT_DEL + " ? (" + temp_array.length + " " + OPT_GROUPS + ")\n\n" + str)) {
		for (var i=0; i<temp_array.length; ++i) {
			for (var j = 0; j < opt_group.length; j++) {
				if (opt_group[j] == temp_array[i]) { opt_group.splice(j,1); debug.trace("del: " + temp_array[i]); }
	
			}
		}
		fnUpdateLstGroups();
		fnUpdateLstStreams();
	} else {         
		//good choise ;)
	}
}

function fnEditGroup() {
	if (!opt_group[lst_groups.selectedIndex]) { return; }
	var old_name = opt_group[lst_groups.selectedIndex];
	var new_name = view.prompt(OPT_NAME + " : ", old_name);
	
	if(new_name) { 
		opt_group[lst_groups.selectedIndex] = new_name; 
		for (var i = 0; i < opt_stream.length; ++i) {	
			if (opt_stream[i].group == old_name) { opt_stream[i].group = new_name; }
		}
		fnUpdateLstGroups();
	}
}

function fnGroupMoveUp() {
	var strTemp = new Array();
	var idTemp;

	var x = lst_groups.selectedIndex;
	
	var id = x;
	if ((id == null) || (id == 0)) { return; }

	idTemp = (id > 0) ? id-- : "";
	strTemp = opt_group[idTemp];

	opt_group[idTemp] = opt_group[id];
	opt_group[id] = strTemp;
	
	fnReloadArrays();
	fnUpdateLstGroups();
	
	x != 0 ? --x : "";
	lst_groups.selectedIndex = x;
}

function fnGroupMoveDown() {
	var strTemp = new Array();
	var idTemp;

	var x = lst_groups.selectedIndex;
	
	var id = x;
		if ((id == null) || (id == (opt_group.length) - 1)) { return; }

	idTemp = (id <= opt_group.length) ? id++ : "";
	strTemp = opt_group[idTemp];

	opt_group[idTemp] = opt_group[id];
	opt_group[id] = strTemp;
	
	fnReloadArrays();
	fnUpdateLstGroups();
	
	x != (lst_groups.children.count) - 1 ? ++x : "";
	lst_groups.selectedIndex = x;
}

// ------------------------------------------------------------------- STREAMS TOOLS
function fnUpdateLstStreams() {
	focus = 0;
	if ((opt_stream.length < 1) || (!lst_groups.selectedItem)) { lst_stations.removeAllElements(); return;}
	lst_stations.removeAllElements();
	for (var i = 0; i < opt_stream.length; ++i) {	
		if (opt_stream[i].group == lst_groups.selectedItem.name) {
			lst_stations.appendElement("<item value='" + i + "' name='" + opt_stream[i].name + "' ondblclick='fnEditStream();'><label height='16' valign='middle' size='9' font='Segoe UI'>" + opt_stream[i].name + "</label></item>");
		}
	}
}

function fnNewStream() {
	if (!opt_group[lst_groups.selectedIndex]) { return; }
	var name = view.prompt(OPT_NEWSTREAM,"");
	var url = view.prompt(OPT_NEWURL,"http://");
	var homepage = view.prompt(OPT_HOMEPAGE,"http://");
	var group = opt_group[lst_groups.selectedIndex];
	
	if (name && url) {
		opt_stream[opt_stream.length] = { name:name, url:url, homepage:homepage, group:group };
		fnUpdateLstStreams();
	}
}

function fnDelStream() {
	var temp_array = [];
	var str = "";

	for (var i=0; i<lst_stations.children.count; ++i) {
		if(lst_stations.children(i).selected) { 
			temp_array.push(lst_stations.children(i).name);
			str += "     " + lst_stations.children(i).name +"\n";
		}
	}

	if (confirm(OPT_DEL + " ? (" + temp_array.length + " " + OPT_STATIONS + ")\n\n" + str)) {
		for (var i=0; i<temp_array.length; ++i) {
			for (var j = 0; j < opt_stream.length; j++) {
				if (opt_stream[j].name == temp_array[i] && opt_stream[j].group == lst_groups.selectedItem.name) { 
					opt_stream.splice(j,1);
					debug.trace("del: " + temp_array[i]);
				}
			}
		}
		fnUpdateLstStreams();
	} else {         
		//good choise ;)
	}
}

function fnEditStream() {
	var id = fnGetId();
	if (id == null) { return; }
	var old_name = opt_stream[id].name;
	var new_name = view.prompt(OPT_NAME + " :",old_name);
	if (new_name) { 
		opt_stream[id].name = new_name; 
		fnUpdateLstStreams();
	
		var old_url = opt_stream[id].url;
		var new_url = view.prompt("URL :",old_url);
		if (new_url) { 
			opt_stream[id].url = new_url; 
			fnUpdateLstStreams();
		
			var old_homepage = opt_stream[id].homepage;
			var new_homepage = view.prompt("Homepage :",old_homepage);
			if (new_homepage) { 
				opt_stream[id].homepage = new_homepage; 
				fnUpdateLstStreams();
			}
		}
	}
}
function fnStreamMoveUp() {
	var strTemp = new Array();
	var idTemp;

	var x = lst_stations.selectedIndex;
	
	var id = fnGetId();
	if ((id == null) || (id == 0)) { return; }

	idTemp = (id > 0) ? id-- : "";
	strTemp = opt_stream[idTemp];

	opt_stream[idTemp] = opt_stream[id];
	opt_stream[id] = strTemp;
	
	fnReloadArrays();
	fnUpdateLstStreams();
	
	x != 0 ? --x : "";
	lst_stations.selectedIndex = x;
}

function fnStreamMoveDown() {
	var strTemp = new Array();
	var idTemp;

	var x = lst_stations.selectedIndex;
	
	var id = fnGetId();
	if ((id == null) || (id == (opt_stream.length) - 1)) { return; }

	idTemp = (id <= opt_stream.length) ? id++ : "";
	strTemp = opt_stream[idTemp];

	opt_stream[idTemp] = opt_stream[id];
	opt_stream[id] = strTemp;
	
	fnReloadArrays();
	fnUpdateLstStreams();

	x != (lst_stations.children.count) - 1 ? ++x : "";
	lst_stations.selectedIndex = x;

}

//----------------------------------------------------------------------------------- MOVE STREAM
function fnMarkGroup() {
	move_group = opt_group[lst_groups.selectedIndex];
	if (!move_group) { return; }
	var selected = lst_groups.selectedIndex;

	lbl_station.innerText = "Target group: " + move_group;
	a_homepage.innerText = "";
	lbl_url.innerText = "";
	
	fnUpdateLstGroups();
	lst_groups.selectedIndex = selected;
}

function fnMoveStream() {
	var temp_array = [];
	var str = "";
	var group = opt_group[lst_groups.selectedIndex];
	
	if (move_group == "") { 
		debug.error ("Select target group.");
		return;
	}

	for (var i=0; i<lst_stations.children.count; ++i) {
		if(lst_stations.children(i).selected) { 
			temp_array.push(lst_stations.children(i).name);
			str += "     " + lst_stations.children(i).name +"\n";
		}
	}
	
	if ( temp_array.length == 0) { return; }
	
	if (confirm("Wish to move " + temp_array.length + " station(s) into [ " + move_group + " ] group?\n\n" + str + "\n Group: " + group)) {
		for (var i=0; i<temp_array.length; ++i) {
			for (var j = 0; j < opt_stream.length; ++j) {
				if (opt_stream[j].name == temp_array[i] && opt_stream[j].group == group) {
					opt_stream[j].group = move_group;
				}
			}
		}
		fnUpdateLstStreams();
	} else {         
		//good choise ;)
	}
}

//----------------------------------------------------------------------------------- GET ID!
function fnGetId() {
	try {
		var name = lst_stations.selectedItem.name;	
		var group = opt_group[lst_groups.selectedIndex];
	} catch(e) { 
		return; 
	}
	var id = null;
	
	for (var i = 0; i < opt_stream.length; i++) {
		if (group == opt_stream[i].group && name == opt_stream[i].name) { id = i; }
	}	
	//debug.info("fnGetId : [" + id + "] " + name + " - " + group);
	opt_id = id;
	return id;
}
//----------------------------------------------------------------------------------- LST_STATIONS CLICK
function fnGetURL() {
	focus = 1;
	var id = fnGetId();
	if (id == null) { return; }
	lbl_station.innerText = opt_stream[id].name + " (" + opt_stream[id].group + ")";
	a_homepage.href = opt_stream[id].homepage;
	a_homepage.innerText = opt_stream[id].homepage;
	lbl_url.innerText = opt_stream[id].url;
}


//----------------------------------------------------------------------------------- KEY DOWN
function fnOptKeyDown() {
  var KeyID = event.keyCode;
	//debug.trace(KeyID);
	switch (KeyID) {
		case 46: // delete
			focus == 0 ? fnDelGroup() : fnDelStream();
		break;
		case 107: // num +
			focus == 0 ? fnGroupMoveDown() : fnStreamMoveDown();
		break;
		case 109: // num -
			focus == 0 ? fnGroupMoveUp() : fnStreamMoveUp();
		break;

	}
}

// ------------------------------------------------------------------- SAVE BLANK gdplayer_playlist.xml
function fnSaveDefaultGDPXML() {
	var xmlDoc=new DOMDocument();
  xmlDoc.async = false;

	var xml_string = "<?xml version=\"1.0\" encoding=\"windows-1250\"?>\n";
	xml_string += "<general>\n";
	xml_string += "</general>";

	xmlDoc.loadXML(xml_string);
	if (xml_string.length == 0) { return; } 
	xmlDoc.save("gdplayer_playlist.xml");
	xmlDoc.close;
	debug.info("default gdplayer_playlist.xml saved...");
}

// ------------------------------------------------------------------- SAVE MODIFIED gdplayer_playlist.xml
function fnSaveGDPXML() {
	var xmlDoc=new DOMDocument();
  xmlDoc.async = false;

	var xml_string = "<?xml version=\"1.0\" encoding=\"windows-1250\"?>\n";
	xml_string += "<general>\n";

	for (var i=0; i<opt_group.length; ++i) {
		xml_string += "<group name='" + opt_group[i] + "'>\n";
		for (var j=0; j<opt_stream.length; ++j) {
			if (opt_stream[j].group == opt_group[i]) {
				xml_string += "<stream>\n";
				xml_string += "<name>" + opt_stream[j].name + "</name>\n";
				xml_string += "<url>" + opt_stream[j].url +"</url>\n";
				xml_string += "<homepage>" + opt_stream[j].homepage +"</homepage>\n";
				xml_string += "</stream>\n";
			}
		}
		xml_string += "</group>\n";
	}
	xml_string += "</general>";

	xmlDoc.loadXML(xml_string);

	try {
		var parseError = xmlDoc.parseError;
		if (parseError.errorCode == 0) {
			xmlDoc.save("gdplayer_playlist.xml"); 
			xmlDoc.close;
			debug.trace("gdplayer_playlist.xml saved...");
		}
	} catch(e) {
		lbl_title.innerText = "failed to save playlist";
		debug.error("failed to save playlist");
		return;
	}
}

// ------------------------------------------------------------------- REINDEX ARRAYS
function fnReloadArrays() {
	var tempArray_1 = new Array();
	var tempArray_2 = new Array();
	var id;

	tempArray_2[0] = { name:"",url:"",homepage:"",group:"" };

	id = 0;
	for (var i=0; i<opt_group.length; ++i) {
		tempArray_1.push(opt_group[i]);
		for (var j=0; j<opt_stream.length; ++j) {
			if (opt_stream[j].group == opt_group[i]) {
				id = ++id;
				tempArray_2[id] = opt_stream[j];
			}
		}
	}
	opt_group = tempArray_1;
	opt_stream = tempArray_2;
}
// ------------------------------------------------------------------- CHANGE BACKGROUND
function fnBgrdLeft() {
	var bgrd_id = options.getValue("bgrd");
	--bgrd_id;
	if (bgrd_id < 1) { bgrd_id = 11; }
	options.putValue("bgrd", bgrd_id);
	preview.src = "images/bgrd_" + bgrd_id + "_undocked.png";
}

function fnBgrdRight() {
	var bgrd_id = options.getValue("bgrd");
	++bgrd_id;
	if (bgrd_id > 11) { bgrd_id = 1; }
	options.putValue("bgrd", bgrd_id);
	preview.src = "images/bgrd_" + bgrd_id + "_undocked.png";
}



// ------------------------------------------------------------------- ONLINE DATABASE
function fnOnline() {	
	div_stations.visible = "false";
	div_server.visible = "true";

	fnGetGroupsXML();

	for (var i=0; i<server_groups.length; ++i) {
			lst_database.appendElement("<item value='" + i + "' name='" +  server_groups[i].filename + "' ondblclick='fnGetGroup();'><label height='14' valign='middle' size='8' font='Segoe UI' color='#FFFFFF'>" + server_groups[i].name + "  (" + server_groups[i].stations + ")</label></item>");
		}
}

function fnOK() {
	fnUpdateLstStreams();
	div_stations.visible = "true";
	div_server.visible = "false";
}


// ------------------------------------------------------------------- PLAY
function fnPlayStream() {
	if (btn_play.caption == PLAY) {
		btn_play.caption = STOP;
	} else {
		btn_play.caption = PLAY;
	}
	var id = fnGetId();
	if (id == null) { return; }
	options.putValue("play", id);
}

// ------------------------------------------------------------------- TESTING

