﻿// gdplayer 0.9.5
// 2.3.2011
// Copyright 2009 - 2011 Zdenek Canik
// All Rights Reserved.
// http://gdplayer.blogspot.com

//var server = "127.0.0.1";
var server = "gdplayer.4fan.cz";
var files = [];
var pls_id;
var intval;
var xxx = 0;


// ------------------------------------------------------------------- LOAD LOCAL gdplayer_playlist.xml
function fnLoadMyList() {
	debug.info("loading local playlist...");
	var xmlDoc = new DOMDocument();
	try {
		xmlDoc.async = false;
		var result = xmlDoc.load("gdplayer_playlist.xml");
		if (!result) {
			debug.trace("local gdplayer_playlist.xml : not found");
			lbl_station.innerText = gdp_version;
			fnSaveDefaultGDPXML();
			return;
		}
		debug.trace("gdplayer_playlist.xml is loaded & ready for use...");
		fnGetArrays(xmlDoc);
	} catch(e) {
		alert(e.message)
	}
}

function fnGetArrays(data) {
	debug.trace("parsing...");
	group = [];
	stream = [];

	var parseError = data.parseError;
	if (parseError.errorCode != 0) { debug.error(parseError.reason); }

	var objGroupList = data.getElementsByTagName("group");
	debug.trace("found : " + objGroupList.length + " group(s)");
	
	var id=-1;
	for (var i = 0; i < objGroupList.length; ++i) {
		var xmlItem = objGroupList.item(i);
		group[i] = xmlItem.getAttribute("name");
		
		for (var j = 0; j < xmlItem.childNodes.length; ++j) {
			var child = xmlItem.childNodes.item(j);
			if (child.childNodes.length > 0) {
				++id;
				try {
					var http = child.childNodes[2].childNodes[0].nodeValue;
				} catch (e) {
					var http = "none";
				}
				stream[id] = {
					name:child.childNodes[0].childNodes[0].nodeValue,
					url:child.childNodes[1].childNodes[0].nodeValue,
					homepage:http,
					group:group[i]
				};
			}
		}
	}
	debug.trace("found : " + stream.length + " stream(s)");
	try {
		np_station = stream[id].name;
		np_group = stream[id].group;
		lbl_title.innerText = "";
	} catch(e) {
		lbl_station.innerText = "";
		lbl_title.innerText = gdp_version + "\n" + EMPTY_PLAYLIST;
		lbl_status.innerText = "";
	}

}

// ------------------------------------------------------------------- DOWNLOAD GROUPS LIST XML
function fnGetGroupsXML() {
	debug.info("downloading groups list from server...");
  try {
		var req = new XMLHttpRequest();
		var url = "http://" + server + "/groups/groups.xml?r=" + Math.random();
		req.open("GET", url, false);
		req.onreadystatechange = function() {
			if (req.readyState == 4) {
				if (req.status == 200) {
					var xmlDoc = new DOMDocument();
					xmlDoc.async = false;
					xmlDoc = req.responseXml;
					debug.trace("groups.xml is downloaded & ready for use...   [ " + url + " ]");
					fnMakeGroupList(xmlDoc);
				}
			}
		};
		req.send();
	} catch(e) {
		alert(e.message);
	}
}

function fnMakeGroupList(data) {
	debug.trace("parsing...");
	server_groups = [];
	var parseError = data.parseError;
  if (parseError.errorCode != 0) {
    debug.error(parseError.reason);
  }
	var objGroupList = data.getElementsByTagName("group");
  debug.trace("found : " + objGroupList.length + " group(s)");
	
	for (var i = 0; i < objGroupList.length; ++i) {
    var xmlItem = objGroupList.item(i);
		server_groups[i] = { 
			name:xmlItem.getAttribute("name"),
			filename:xmlItem.childNodes[0].childNodes[0].nodeValue,
			stations:xmlItem.childNodes[1].childNodes[0].nodeValue
		};
	}
	lbl_status.innerText = objGroupList.length + " " + GROUP_LIST_LOADED;
}

// ------------------------------------------------------------------- DOWNLOAD & ADD GROUP
function fnGetGroup() {	
	if (!lst_database.selectedItem) { return; }
	
	var filename;
	filename = lst_database.selectedItem.name;
	
	var str = OPT_DOWNLOADING + ": " + server_groups[lst_database.selectedIndex].name;
	lbl_station.innerText = str;

  var req = new XMLHttpRequest();
	var url = "http://" + server + "/groups/" + filename + ".xml?r=" + Math.random();
	
	debug.info("downloading group : " + url);
	req.open("GET", url, true);
  req.onreadystatechange = function() {
      if (req.readyState == 4) {
        if (req.status == 200) {
					var xmlDoc = new DOMDocument();
					xmlDoc.async = false;
					xmlDoc = req.responseXml;
					debug.trace("group [ " + filename + ".xml ] is loaded & ready for use...");
					fnAddGroup(xmlDoc);
        }
      }
    };
  req.send();
}

function fnAddGroup(data) {
//	debug.info("adding group to menu...");

	var parseError = data.parseError;
	if (parseError.errorCode != 0) {
		debug.error(parseError.reason);
	}

	var objGroupList = data.getElementsByTagName("group");
	
	for (var i = 0; i < objGroupList.length; ++i) {
		var xmlItem = objGroupList.item(i);
		var group_name = xmlItem.getAttribute("name");
		var a = false;
		for (var j = 0; j < opt_group.length; ++j) {
				if (opt_group[j] == group_name) { a = true; }
		}
		if (!a) { 
			opt_group.push(group_name);
		}

		var x = opt_stream.length - 1;
		for (var j = 0; j < xmlItem.childNodes.length; ++j) {
			var child = xmlItem.childNodes.item(j);
			if (child.childNodes.length > 0) {
				var name = child.childNodes[0].childNodes[0].nodeValue;
				a = false;
				for (var k = 0; k < opt_stream.length; ++k) {
					if ((opt_stream[k].name == name) && (opt_stream[k].group == group_name )) { 
						var a = true;
						opt_stream[k].url = child.childNodes[1].childNodes[0].nodeValue;
					}	
				}
				if (!a) {
					try {
						var http = child.childNodes[2].childNodes[0].nodeValue;
					} catch(e) {
						var http = "none";
					}
					//debug.info("new stream : " + name + " @ " + child.childNodes[1].childNodes[0].nodeValue + " *** " + http);
					x++;
					opt_stream[x] = {
						name:name,
						url:child.childNodes[1].childNodes[0].nodeValue,
						homepage:http,
						group:group_name
					};
				}
			}
		}
			
	}

	var str = OPT_GROUP_ADDED + " " + group_name + "    (" +  xmlItem.childNodes.length + " stations)";
	lbl_station.innerText = str;
	lbl_url.innerText = "";
	a_homepage.innerText = "";
	fnUpdateLstGroups();
}

// ------------------------------------------------------------------- PARSE AND PLAY .PLS
function fnPlayPLS() {
	pls_id = 0;

	try {	
		debug.info("downloading .pls playlist...");
		var allText;
		var lines = [];
		files = [];
		var req = new XMLHttpRequest();

		fnStop();
		
		req.open("GET", stream[id].url, false);
		req.onreadystatechange = function() {
			if (req.readyState == 4) {
				lines = req.responseText.split("\n");
				for (var i = 0; i < lines.length; ++i) {
					if (lines[i].slice(0,4) == "File") {
						var a = lines[i].indexOf("=") + 1;
						files.push(lines[i].substr(a));
					}
				}
			}
		};
		req.send();
		debug.trace("url : " + stream[id].url);		
		debug.trace("entries : " + files.length);
		setTimeout('fnCheckPlayer()',0);
	} catch(e) {
		//alert(e.message);
		lbl_title.innerText = "URL error";
	}
}

function fnCheckPlayer() {
	if (player.playState == 3 || pls_id >= files.length) { return; }
	if ((player.playState != 10) && (player.playState != 0)) { 
		setTimeout('fnCheckPlayer()',1000);
		return; 
	}
	
	player.url = files[pls_id];
	debug.trace("play : " + player.url);
	player.controls.play();
	pls_id++;
}

// ----------------------------------------------------------------------------------------------------------------------------------- TEST
